#include <stdio.h>
#include <string.h>

/* programa en C que muestra cmo se implementa el paso de una estructura 
   a una funcin tanto por copia como por referencia */

typedef struct
{
 char nombre[30];
 int edad;
 long mat;
 int nrc;
 char nombre_carrera[20];        
} t_alumno;

void cargar_alumno(t_alumno *alumno); 
void mostrar_alumno(t_alumno alumno);

int main()
{
 t_alumno alumno;
 
 cargar_alumno(&alumno); //Llamado de una funcin donde se le pasa como 
                         //argumento la direccin de una estructura (paso
                         //por referencia)
                         
 mostrar_alumno(alumno); //Llamado de una funcin donde se le pasa como
                         //argumento una estructura (paso por valor)
 
 printf("\n");
 system("pause");
 return 1;   
}

//paso de la struct como parmetro por referencia
void cargar_alumno(t_alumno *alumno)
   {
    printf("Ingrese los datos del alumno\n\n");
    printf("Nombre: ");
    fgets(alumno->nombre,30,stdin);
    if (alumno->nombre[strlen(alumno->nombre)-1]=='\n')
       alumno->nombre[strlen(alumno->nombre)-1]='\0';
    else while(getchar()!='\n');
    
    printf("Edad: ");
    scanf("%d", &(alumno->edad)); //equivale a (*alumno).edad
    while(getchar()!='\n');
    
    printf("Matricula: ");
    scanf("%ld", &(alumno->mat));
    while(getchar()!='\n');
    
    printf("NRC de la carrera: ");
    scanf("%d", &(alumno->nrc));
    while(getchar()!='\n');
    
    printf("Nombre de la carrera: ");
    fgets(alumno->nombre_carrera,20,stdin);
    if (alumno->nombre_carrera[strlen(alumno->nombre_carrera)-1]=='\n')
       alumno->nombre_carrera[strlen(alumno->nombre_carrera)-1]='\0';
    else while(getchar()!='\n');
   }
   
//paso de la struct como parmetro por valor
void mostrar_alumno(t_alumno alumno)
   {
    printf("\nDATOS DEL ALUMNO:\n\n");
    printf("Nombre %s\n",alumno.nombre);
    printf("Edad %d\n",alumno.edad);
    printf("Matricula %ld\n",alumno.mat);
    printf("NRC de la carrera %d\n",alumno.nrc);
    printf("Nombre de la carrera %s\n",alumno.nombre_carrera);
   }
